package com.muyu.rule.server.pool.container;

import com.muyu.rule.server.EngineConfig;
import com.muyu.rule.server.annotation.EngineParam;
import com.muyu.rule.server.load.JavaBinaryClassLoader;
import com.muyu.rule.server.pool.RuleEngineException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server
 * @Project：cloud-etl-rule
 * @name：EngineContainer
 * @Date：2024/8/22 22:32
 */
public class EngineContainer {


    private static final Logger log = LoggerFactory.getLogger(JavaBinaryClassLoader.class);

    private static Map<String ,Object> methodMap = new ConcurrentHashMap<>(16);

    private static Map<String ,Object> classMap = new ConcurrentHashMap<>(16);

    private static Map<String ,Object> instanceMap = new ConcurrentHashMap<>(16);




public static void loadEngineInstance(String engineKey,Class<?> clazz){


  Method method = findMethodByClass(EngineConfig.executionMethodName,clazz);

  if (method ==null){
      log.info("初始化规则引擎 -> {}  失败 缺少 {} 方法",engineKey,EngineConfig.executionMethodName);
      return;
  }

    try {
        instanceMap.put(engineKey,clazz.newInstance());
    } catch (InstantiationException e) {
        throw new RuntimeException(e);
    } catch (IllegalAccessException e) {
        throw new RuntimeException(e);
    }
    classMap.put(engineKey,clazz);
    methodMap.put(engineKey,method);
    Class<?>[] parameterTypes = method.getParameterTypes();
    Annotation[][] parameterAnnotations = method.getParameterAnnotations();
    //获取参数
    ArrayList<String> engineParams = new ArrayList<>();

    int parameterTypeLength = parameterTypes.length;
    for (int i = 0; i < parameterTypeLength; i++) {
     Annotation[] paramAnn =   parameterAnnotations[i];
     if (paramAnn.length == 0){
         throw new RuleEngineException("请给所有参数填写注释!");
     }
     if (paramAnn.length>1){
         throw new RuleEngineException("参数仅支持一个注释!");
     }
     EngineParam engineParam =null;
     if (paramAnn[0] instanceof EngineParam){
         engineParam = (EngineParam) paramAnn[0];
     }

     if (engineParam ==null){
         throw new RuleEngineException("请使用EngineParam注解");
     } else if (engineParam.name() == null) {
         throw new RuleEngineException("engineParam -- name 不可为null");
     }
     engineParams.add(engineParam.name());
    }


}

    private static Method findMethodByClass(Object executionMethodName, Class<?> clazz) {




return null;
}


    public static List<String> getMethodEngineParamMap(String engineKey) {



return null;
}


    public static Object getInstanceMap(String engineKey) {




return null;
}


    public static Method getMethodMap(String engineKey) {

return null;

}

    public static int getSumEngine() {

        return 1;
    }

}
