package com.muyu.rule.server.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.rule.common.domain.RuleEngineVersion;
import com.muyu.rule.server.service.RuleEngineVersionService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server.service.impl
 * @Project：cloud-etl-rule
 * @name：RuleEngineServiceImpl
 * @Date：2024/8/25 14:17
 */
@Service
public class RuleEngineServiceImpl extends ServiceImpl<BaseMapper<RuleEngineVersion>,RuleEngineVersion> implements RuleEngineVersionService {


    @Override
    public List<RuleEngineVersion> selectRuleEngineVersion(Long id) {

        LambdaQueryWrapper<RuleEngineVersion> queryWrapper = new LambdaQueryWrapper<>();

        queryWrapper.eq(
     RuleEngineVersion::getRuleId,id);

        List<RuleEngineVersion> versionList = this.list(queryWrapper);


        return versionList;
    }

}
